

#define INCL_DOS
#define INCL_WIN
#include <os2.h>
#include <stdio.h>
#include <string.h>
#include <assert.h>
#include "..\engine\globals.h"


#define MEMPOOL 16384


int main()
{
	APIRET 		rc;
	ULONG		ulRC;
	
	PTIB		ptib;
	PPIB		ppib;
	
	HAB			hab;
	HMQ			hmq;
	
	HMODULE		hm;
	CHAR		pszLoadError[ 256 ];
	
	HQUEUE      hqInstHookDone; // for RC queue
	REQUESTDATA	rd;
	PVOID		pBuf;
	ULONG		cbData;
	BYTE		bPriority;
	HEV			hevInstHookDone;

    ULONG       cbItems    = 0,
                ulBufSize  = 0;
    PSWBLOCK    pswblk     = NULL;
    PVOID       pvSwList   = NULL;
    HWND		hwndTlw;
    HWND		hwndCntr;
    int			i;

	PRECORDCORE	pRecord;

	/*
	 *  mark this process as PM and initialize
	 *
	 **/

	//rc = DosGetInfoBlocks( &ptib, &ppib );
	//assert( !rc );
	//ppib->pib_ultype = SSF_TYPE_PM;
	
	hab = WinInitialize( 0 );
	assert( hab );
	hmq = WinCreateMsgQueue( hab, 0 );
	assert( hmq );
	
    rc = DosAllocMem( &pvSwList, MEMPOOL, PAG_READ | PAG_WRITE );
    rc = DosSubSetMem( pvSwList, DOSSUB_INIT | DOSSUB_SPARSE_OBJ, MEMPOOL );

    cbItems = WinQuerySwitchList( 0, NULL, 0 );
    ulBufSize = ( cbItems * sizeof( SWENTRY ) ) + sizeof( HSWITCH );

    rc = DosSubAllocMem( pvSwList, ( PVOID ) &pswblk, ulBufSize );
    cbItems = WinQuerySwitchList( 0, pswblk, ulBufSize );

	hwndTlw = 0;
	for( i = 0; i < cbItems; i++ )
		if( pswblk->aswentry[ i ].swctl.idProcess == 0 )
		{
			hwndTlw = pswblk->aswentry[ i ].swctl.hwnd;
			break;
		};
		
	
    assert( hwndTlw );
    if( !hwndTlw )
    	return -1;

	hwndCntr = WinWindowFromID( WinWindowFromID( hwndTlw, FID_CLIENT ), TLW_CONTAINER );

	DosSleep( 5000 );
	

	pRecord = WinSendMsg( hwndCntr,
				          CM_QUERYRECORDEMPHASIS,
				          MPFROMLONG( CMA_FIRST ),
				          MPFROMSHORT( CRA_SELECTED ) );
				    	
	while( pRecord > 0 )
	{
		//printf( "%s\n", pRecord->pszIcon );
		
		pRecord = WinSendMsg( hwndCntr,
					CM_QUERYRECORDEMPHASIS,
					MPFROMLONG( pRecord ),
					MPFROMSHORT( CRA_SELECTED ) );
					
	};
	
	
	
	
	
	DosFreeMem( pvSwList );
	
    return 0;
};

