/*
 *  By Sharon Dagan, IBM Israel <idagan@il.ibm.com>
 *  (C) 1998, All Rights Reserved, Israel.
 *
 *  $Date: 1998/07/29 11:33:25 $
 *  $Id: tlw_winproc.c,v 1.3 1998/07/29 11:33:25 idagan Exp idagan $
 *
 *  Here is the window procedure that is used to replace the standard window
 *  procedure of the task list window. When this code becomes active, it will
 *  monitor three events encapsulated within a WM_NULL message.
 *
 *  1. NICE_WM_CHANGEPRIORITY is used to change priority when the request is
 *     a PRTYS_PROCESS.
 *
 *  2. NICE_WM_INSTALLHOOK is used to install a system wide hook so that a
 *     following PRTYS_THREAD priority request can be satisfied.
 *
 *  3. NICE_WM_REMOVEHOOK is used to remove the previously install hook.
 *
 **/

#define INCL_DOS
#define INCL_WIN
#include <os2.h>
#include "hack.h"
#include "menu.h"


PFNWP 	OriginalTlwWinProc;		
HMODULE hmTlw;


MRESULT _System TlwWinProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
    MRESULT 	result;
    HWND		hwndCntxMenu;
    HWND		hwndPriorityMenu;
    MENUITEM 	mi;
    MENUITEM 	miSep;

	switch( msg )
	{
		case WM_CONTROL:
			if( SHORT2FROMMP( mp1 ) == CN_CONTEXTMENU )
			{
				miSep.iPosition = MIT_END;
				miSep.afStyle = MIS_SEPARATOR;
				miSep.afAttribute = 0;
				miSep.id = -1;
				miSep.hwndSubMenu = 0;
				miSep.hItem = 0;
		
				hwndPriorityMenu = WinLoadMenu( HWND_DESKTOP,
												hmTlw,
												IDM_PRIORITY_MENU );
				mi.iPosition = MIT_END;
				mi.afStyle = MIS_SUBMENU;
				mi.afAttribute = 0;
				mi.id = IDM_PRIORITY_MENU;
				mi.hwndSubMenu = hwndPriorityMenu;
				mi.hItem = 0;
			
				result = ( MRESULT ) OriginalTlwWinProc( hwnd, msg, mp1, mp2 );
				hwndCntxMenu = WinWindowFromID( HWND_DESKTOP, TLW_CNTXMENU_ID );
			
				if( hwndPriorityMenu )
				{
					WinSendMsg( hwndCntxMenu,
			        	    	MM_INSERTITEM,
			            		( MPARAM ) &miSep,
			            		( MPARAM ) "" );
			
					WinSendMsg( hwndCntxMenu,
								MM_INSERTITEM,
								( MPARAM ) &mi,
								( MPARAM ) "~Priority" );			
				};
			
				return result;
            };

            break;

		case WM_COMMAND:
			switch( ( ULONG ) mp1 )
			{
				case IDM_INCREASE_DELTA:
				
					DosBeep( 100, 100 );
					break;
			};

			break;
			
		default:
			break;
	};			
	

    return ( MRESULT ) OriginalTlwWinProc( hwnd, msg, mp1, mp2 );
};


